package org.dolphinemu.dolphinemu;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

public final class GameListItem implements Comparable<GameListItem>
{
    private final String name;
    private final String data;
    private final String path;
    private final boolean isValid;
    private Bitmap image;

    public GameListItem(Context ctx, String name, String data, String path, boolean isValid)
    {
        this.name = name;
        this.data = data;
        this.path = path;
	    this.isValid = isValid;
	    
        File file = new File(path);
        if (!file.isDirectory() && !path.equals(""))
        {
        	int[] Banner = NativeLibrary.GetBanner(path);
        	if (Banner[0] == 0)
        	{
        		try
        		{
					InputStream noBannerPath = ctx.getAssets().open("NoBanner.png");
					image = BitmapFactory.decodeStream(noBannerPath);
				}
        		catch (IOException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        		
        	}
        	else
        	{
        		image = Bitmap.createBitmap(Banner, 96, 32, Bitmap.Config.ARGB_8888);
        	}
        	
        	name = NativeLibrary.GetTitle(path);
        }
    }
    
    public String getName()
    {
        return name;
    }
    
    public String getData()
    {
        return data;
    }
    
    public String getPath()
    {
        return path;
    }
    
    public Bitmap getImage()
    {
    	return image;
    }
    
	public boolean isValid()
	{
		return isValid;
	}
    
    public int compareTo(GameListItem o) 
    {
        if(this.name != null)
            return this.name.toLowerCase().compareTo(o.getName().toLowerCase()); 
        else 
            throw new IllegalArgumentException();
    }
}

